//+------------------------------------------------------------------+
//|                                      matr_mul_1dim_coalesced.mq5 |
//+------------------------------------------------------------------+
#property script_show_inputs

#define ROWS1       2000      //    
#define COLSROWS    2000      //    =    
#define COLS2       2000      //   
#define REALTYPE    float

REALTYPE first[];             //    ()     rows1 * colsrows
REALTYPE second[];            //                            colsrows * cols2
REALTYPE thirdGPU[ ];         //   -        rows1 * cols2
REALTYPE thirdCPU[ ];         //   -        rows1 * cols2

input int _device=1;          //  ,  

string d2s(double arg,int dig) { return DoubleToString(arg,dig); }
string i2s(int arg)            { return IntegerToString(arg); }

//+------------------------------------------------------------------+
const string clSrc=
                   "#define COLS2     "+i2s(COLS2)+"                                      \r\n"
                   "#define COLSROWS  "+i2s(COLSROWS)+"                                   \r\n"
                   "#define REALTYPE  float                                               \r\n"
                   "                                                                      \r\n"
                   "__kernel void matricesMul( __global REALTYPE *in1,                    \r\n"
                   "                           __global REALTYPE *in2,                    \r\n"
                   "                           __global REALTYPE *out  )                  \r\n"
                   "{                                                                     \r\n"
                   "  int r = get_global_id( 0 );                                         \r\n"
                   "  int c = get_global_id( 1 );                                         \r\n"
                   "  for( int cr = 0; cr < COLSROWS; cr ++ )                             \r\n"
                   "     out[ r * COLS2 + c ] +=                                          \r\n"
                   "              in1[ r * COLSROWS + cr ] * in2[ cr + c * COLSROWS ];    \r\n"
                   "}                                                                     \r\n";
//+------------------------------------------------------------------+
//| mulCPUOneCore                                                    |
//|    ;                               |
//|   ,          |
//+------------------------------------------------------------------+
void mulCPUOneCore()
  {
// c-r-cr: 11.544 s 
//st = GetTickCount( );

   for(int c=0; c<COLS2; c++)
      for(int r=0; r<ROWS1; r++)
         for(int cr=0; cr<COLSROWS; cr++)
            //thirdCPU[r*COLS2+c]+=first[r*COLSROWS+cr]*second[cr*COLS2+c];            
	    thirdCPU[ r * COLS2 + c ] += first[ r * COLSROWS + cr ] * second[ cr + c * COLSROWS ];	                
            

//time = ( REALTYPE ) ( GetTickCount( ) - st ) / 1000.;
//Print( "CPU: c-r-cr: time = " + DoubleToString( time, 3 ) + " s." );

/*
   // r-c-cr: 13.307 s 
   st = GetTickCount( );
      for( int r = 0; r < ROWS1; r ++ )
   for( int c = 0; c < COLS2; c ++ )         
         for( int cr = 0; cr < COLSROWS; cr ++ )
           third[ r * COLS2 + c ] += first[ r * COLSROWS + cr ] * second[ cr * COLS2 + c ];
   time = ( double ) ( GetTickCount( ) - st ) / 1000.;
   Print( "CPU: r-c-cr: time = " + DoubleToString( time, 3 ) + " s." );

   // c-cr-r: 17.800 s 
   st = GetTickCount( );
   for( int c = 0; c < COLS2; c ++ )         
         for( int cr = 0; cr < COLSROWS; cr ++ )
      for( int r = 0; r < ROWS1; r ++ )
           third[ r * COLS2 + c ] += first[ r * COLSROWS + cr ] * second[ cr * COLS2 + c ];           
   time = ( double ) ( GetTickCount( ) - st ) / 1000.;
   Print( "CPU: c-cr-r: time = " + DoubleToString( time, 3 ) + " s." );

   // r-cr-c: 10.265 s 
   st = GetTickCount( );
      for( int r = 0; r < ROWS1; r ++ )
         for( int cr = 0; cr < COLSROWS; cr ++ )
   for( int c = 0; c < COLS2; c ++ )         
           third[ r * COLS2 + c ] += first[ r * COLSROWS + cr ] * second[ cr * COLS2 + c ];           
   time = ( double ) ( GetTickCount( ) - st ) / 1000.;
   Print( "CPU: r-cr-c: time = " + DoubleToString( time, 3 ) + " s." );

   // cr-c-r: 17.738 s 
   st = GetTickCount( );   
         for( int cr = 0; cr < COLSROWS; cr ++ )
   for( int c = 0; c < COLS2; c ++ )         
      for( int r = 0; r < ROWS1; r ++ )
           third[ r * COLS2 + c ] += first[ r * COLSROWS + cr ] * second[ cr * COLS2 + c ];           
   time = ( double ) ( GetTickCount( ) - st ) / 1000.;
   Print( "CPU: cr-c-r: time = " + DoubleToString( time, 3 ) + " s." );

   // cr-r-c: 10.358 s 
   st = GetTickCount( );   
         for( int cr = 0; cr < COLSROWS; cr ++ )
      for( int r = 0; r < ROWS1; r ++ )
   for( int c = 0; c < COLS2; c ++ )         
           third[ r * COLS2 + c ] += first[ r * COLSROWS + cr ] * second[ cr * COLS2 + c ];           
   time = ( double ) ( GetTickCount( ) - st ) / 1000.;
   Print( "CPU: cr-r-c: time = " + DoubleToString( time, 3 ) + " s." );
*/
   return;
  }
//+------------------------------------------------------------------+
//| Script program start function                                    |
//+------------------------------------------------------------------+
void OnStart()
  {
   initAllDataCPU();

//---      ("" CPU,  )
//---       CPU
   uint st=GetTickCount();
   mulCPUOneCore();

//---    
   double timeCPU=(GetTickCount()-st)/1000.;
   Print("CPUTime = "+d2s(timeCPU,3));

//---    OCL
   int clCtx;             //  
   int clPrg;             //    
   int clKrn;             //  
   int clMemIn1;          //    ()
   int clMemIn2;          //    ()
   int clMemOut;          //    ()

//---       GPU  
//st = GetTickCount( );  
   initAllDataGPU(clCtx,clPrg,clKrn,clMemIn1,clMemIn2,clMemOut);

//---       OCL
   st=GetTickCount();

   executeGPU(clKrn);

//---       ;    
   REALTYPE buf[];
   readOutBuf(clMemOut,buf);

//---       
//---       GPU   RAM
   double timeGPUTotal=(GetTickCount()-st)/1000.;
   Print("OpenCL total: time = "+d2s(timeGPUTotal,3)+" sec.");

   destroyOpenCL(clCtx,clPrg,clKrn,clMemIn1,clMemIn2,clMemOut);

//---   
   Print("CPUTime / GPUTotalTime = "+d2s(timeCPU/timeGPUTotal,3));

//--- :  .          
//---     
   for(int i=0; i<10; i++) checkRandom(buf,ROWS1,COLS2);

   Print("________________________");
   return;
  }
//+------------------------------------------------------------------+
//| initAllDataCPU                                                   |
//+------------------------------------------------------------------+
void initAllDataCPU()
  {
//---    
   MathSrand(( int) TimeLocal());
   Print("=======================================");
   Print("1st OCL martices mul:  device = "+i2s(_device)+";      ROWS1 = "+i2s(ROWS1)+"; COLSROWS = "+i2s(COLSROWS)+"; COLS2 = "+i2s(COLS2));

//---         
   ArrayResize(first,ROWS1*COLSROWS);
   ArrayResize(second,COLSROWS*COLS2);
   ArrayResize(thirdGPU,ROWS1*COLS2);
   ArrayResize(thirdCPU,ROWS1*COLS2);

//---         
   genMatrices();
   ArrayInitialize( thirdCPU, 0.0 );
   ArrayInitialize( thirdGPU, 0.0 );

   return;
  }
//+------------------------------------------------------------------+
//| genMatrices                                                      | 
//|   , Matr[ M () ][ N () ]:        |
//| Matr[row][column] = buff[ row * N (  ) + column] |
//|   ;             | 
//|                         | 
//|    !                                     | 
//+------------------------------------------------------------------+
void genMatrices()
  {
   for(int r=0; r<ROWS1; r++)
      for(int c=0; c<COLSROWS; c++)
         first[r*COLSROWS+c]=genVal();

//---  :     (   )
   for(int r=0; r<COLSROWS; r++)
      for(int c=0; c<COLS2; c++)
         // second[ r * COLS2 + c ] = genVal( );
         second[r+c*COLSROWS]=genVal();

   return;
  }
//+------------------------------------------------------------------+
//| genVal                                                           |
//|     :                       |
//|      [-0.5; 0.5]        |
//+------------------------------------------------------------------+
REALTYPE genVal()
  {
   return(REALTYPE)(( MathRand()-16383.5)/32767.);
  }
//+------------------------------------------------------------------+
//| initAllDataGPU                                                   |
//+------------------------------------------------------------------+
void initAllDataGPU(int &clCtx,         // 
                    int& clPrg,         //   
                    int& clKrn,         // 
                    int& clMemIn1,      //   ()
                    int& clMemIn2,      //   ()
                    int& clMemOut)      //   ()
  {
//---     
   WriteCLProgram();

//---  ,   
   clCtx = CLContextCreate( _device );
   clPrg = CLProgramCreate( clCtx, clSrc );
   clKrn = CLKernelCreate( clPrg, "matricesMul" );

//---       
//---   - 
   clMemIn1=CLBufferCreate(clCtx,ROWS1   *COLSROWS *sizeof(REALTYPE),CL_MEM_READ_WRITE);
//---   - 
   clMemIn2=CLBufferCreate(clCtx,COLSROWS*COLS2    *sizeof(REALTYPE),CL_MEM_READ_WRITE);
//---   - 
   clMemOut=CLBufferCreate(clCtx,ROWS1   *COLS2    *sizeof(REALTYPE),CL_MEM_READ_WRITE);

//---   
   CLSetKernelArgMem(clKrn,0,clMemIn1);
   CLSetKernelArgMem(clKrn,1,clMemIn2);
   CLSetKernelArgMem(clKrn,2,clMemOut);

//---      
   CLBufferWrite(clMemIn1,first);
   CLBufferWrite(clMemIn2,second);
   CLBufferWrite(clMemOut,thirdGPU);   // 0.0 

   return;
  }
//+------------------------------------------------------------------+
//| WriteCLProgram                                                   |
//+------------------------------------------------------------------+
void WriteCLProgram()
  {
   int h=FileOpen("matr_mul_OCL_1st.cl",FILE_WRITE|FILE_TXT|FILE_ANSI);
   FileWrite(h,clSrc);
   FileClose(h);
  }
//+------------------------------------------------------------------+
//| executeGPU                                                       |
//+------------------------------------------------------------------+
void executeGPU(int clKrn)
  {
//---         OpenCL
   uint offs[ 2 ]  = { 0, 0 };
   uint works[ 2 ] = { ROWS1,  COLS2 };
   bool ex=CLExecute(clKrn,2,offs,works);
   return;
  }
//+------------------------------------------------------------------+
//| readOutBuf                                                       |
//+------------------------------------------------------------------+
void readOutBuf(int clMemOut,REALTYPE &buf[])
  {
   ArrayResize(buf,COLS2*ROWS1);
//--- buf -  ,     thirdGPU[]
   uint read=CLBufferRead(clMemOut,buf);
   Print("read = "+i2s(read)+" elements");
   return;
  }
//+------------------------------------------------------------------+
//| destroyOpenCL                                                    |
//+------------------------------------------------------------------+
void destroyOpenCL(int clCtx,int clPrg,int clKrn,int clMemIn1,int clMemIn2,int clMemOut)
  {
//---           OpenCL
   CLBufferFree(clMemIn1);
   CLBufferFree(clMemIn2);
   CLBufferFree(clMemOut);
   CLKernelFree(clKrn);
   CLProgramFree(clPrg);
   CLContextFree(clCtx);
   return;
  }
//+------------------------------------------------------------------+
//| checkRandom                                                      |
//|                           |
//+------------------------------------------------------------------+
void checkRandom(REALTYPE &buf[],int rows,int cols)
  {
   int r0 = genRnd( rows );
   int c0 = genRnd( cols );

   REALTYPE sum=0.0;
   for(int runningIdx=0; runningIdx<COLSROWS; runningIdx++)
      ///sum+=first[r0*COLSROWS+runningIdx]*second[runningIdx*COLS2+c0];
      sum += first[ r0 * COLSROWS + runningIdx ] * second[ runningIdx + c0 * COLSROWS ];

//---   m[]
   REALTYPE bufElement=buf[r0*COLS2+c0];
//---  ,    OpenCL
   REALTYPE CPUElement=thirdCPU[r0*COLS2+c0];

   Print("sum( "+i2s(r0)+","+i2s(c0)+" ) = "+d2s(sum,8)+
         ";    thirdCPU[ "+i2s(r0)+","+i2s(c0)+" ] = "+d2s(CPUElement,8)+
         ";    buf[ "+i2s(r0)+","+i2s(c0)+" ] = "+d2s(bufElement,8));
   return;
  }
//+------------------------------------------------------------------+
//| genRnd                                                           |
//+------------------------------------------------------------------+
int genRnd(int max)
  {
   return(int)(MathRand()/32767.*max);
  }
//+------------------------------------------------------------------+
